/*
 *	main.c
 *
 *	Vv[U[
 *
 *	* Thu Jan  2 10:00:00 JST 2003 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		30			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

const CHR chr_ship[2][3] = {
	{{0x10,2,1,7,7},{0x12,2,1,7,7},{0x14,2,1,7,7}},
	{{0x20,2,1,7,0},{0x22,2,1,7,0},{0x24,2,1,7,0}},
};
const CHR chr_debris[3] = {
	{0x01,1,1,3,3},{0x02,1,1,3,3},{0x03,1,1,3,3},
};

#define SHIP_X_MIN		(( 0 + 7) << 8)
#define SHIP_X_MAX		((88 - 7) << 8)
#define SHIP_SPEED		256
#define SHIP_FREEZE_TIME	3		/* [U[B̍d */
#define SHIP_BREAK_TIME		SEC(1.5)	/* j */
#define SHIP_FUEL_UNIT		5		/* [U[1iނ̂ɕKvȔR */

#define SHIP_NORMAL		1
#define SHIP_LASER		2
#define SHIP_FREEZE		3
#define SHIP_BREAK		4
#define SHIP_WAIT		5

typedef struct _SHIP {
	int stat;		/* (SHIP_*) */
	int x, y;		/* ʒu(8rbg) */
	int fuel;		/* R(0`100) */
	int cnt;		/* ėpJE^ */
	int ai[16];		/* AIpϐ */
} SHIP;

#define DEBRIS_X_MIN		(( 0 - 4) << 8)
#define DEBRIS_X_MAX		((88 + 4) << 8)
#define DEBRIS_COLS		3
#define DEBRIS_ROWS		7
#define DEBRIS_SPEED		128

#define DEBRIS_NORMAL		1
#define DEBRIS_BREAK		2

typedef struct _DEBRIS {
	int stat;		/* (DEBRIS_*) */
	int x, y;		/* ʒu(8rbg) */
	int dir;		/* 0:ړ/1:Eړ */
	int pts;		/* _ */
	int cnt;		/* ėpJE^ */
} DEBRIS;

typedef struct _GI {
	int score;
	int round;
	int left;
	SHIP ship[2];
	DEBRIS debris[DEBRIS_ROWS][DEBRIS_COLS];
} GI;

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;		/* WbCuŒ`ĂȂ̂ */

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int hiscore;
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void ship_work();
void debris_work();
int field_disp(int obj);
int ship_think(int side);

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
//	int retval;

//	/* hFǂݍ݂܂B */
//	thread_lock();
//	retval = loadInst();
//	thread_unlock();
//	if(retval != 0) {
//		grcls(3);
//		symbol(4, 34, "drum.binǂݍݎsł", 0, 0);
//		symbol(4, 44, "h͍Đ܂", 0, 0);
//		wait(3000);
//		grcls(-1);
//	}

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 0,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 3);	/* wiF(wʕ\Ȃ̂) */

	srand(msec());
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause; /* PAUSEԐ؂ւ */
			if(!pause) pausedisp(0);
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(msec() % 1000 < 750) {
			pausedisp(1);
		} else {
			pausedisp(0);
		}
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result;

	/* ʃNAB */
	bgcls();
	grcls(-1);
	spcls(0);

	/* ^Cg\B */
	grputstr(4, 4, "SIMPLE  ", 0xf0);
	grputstr(4, 5, "   LASER", 0xf0);

	/* XRA\B */
	grputstr(0, 0, "HI", 0xf0);
	grprintf(0, 1, 0xf0, "%05d", hiscore  <= 99999 ? hiscore  : 99999);
	grputstr(11, 0, "1P", 0xf0);
	grprintf(11, 1, 0xf0, "%05d", gi.score <= 99999 ? gi.score : 99999);

	for(;;) {
		schedule();

		/* Q[JnA܂͏IH */
		if(joy & TRG_A     ) { result =  0; break; }
		if(joy & TRG_SELECT) { result = -1; break; }

		/* vvg\B */
		grprintf(3,  9, 0xf0, now % SEC(0.75) < SEC(0.5) ? "[ A ] START" : "           ");
		grprintf(3, 10, 0xf0, now % SEC(0.75) < SEC(0.5) ? "[SEL] EXIT " : "           ");
	}
	sound(3);

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static void
round_init()
{
	int obj, side, col, row, i, x, y;
	SHIP* ship;
	DEBRIS* debris;

	/* CA覐΂NAB */
	memset(gi.ship, 0, sizeof gi.ship);
	memset(gi.debris, 0, sizeof gi.debris);

	/* x\B */
	grcls(-1);
	for(i = 0; i < SEC(1.5); i++) {
		schedule();
		if((i >= SEC(0.5)) && (joy & (TRG_A | TRG_B))) break; /* 0.5bȍ~̓LZ\ */
		if(i % SEC(0.5) < SEC(0.3)) {
			grprintf(2, 5, 0xf0, "ROUND%2d", (gi.round + 1) <= 99 ? (gi.round + 1) : 99);
		} else {
			grprintf(2, 5, 0xf0, "       ");
		}
		obj = 0;
		obj = field_disp(obj);
		spcls(obj);
	}
	grprintf(2, 5, 0xf0, "       "); /* mROUND\ */

	/* C䏉B */
	for(side = 0; side < 2; side++) {
		ship = &gi.ship[side];
		ship->stat = SHIP_NORMAL;
		if(side == 0) {
			x = SHIP_X_MIN;
			y = (DISP_Y - 1) << 8;
		} else {
			x = SHIP_X_MAX - 1;
			y = 0 << 8;
		}
		ship->x = x;
		ship->y = y;
	}

	/* 覐ΏB */
	y = (16 + 3) << 8;
	for(row = 0; row < DEBRIS_ROWS; row++) {
		for(col = 0; col < DEBRIS_COLS; col++) {
			debris = &gi.debris[row][col];
			debris->stat = DEBRIS_NORMAL;
			debris->dir = row & 1;
			x = (88 * col / DEBRIS_COLS + rnd(88 / DEBRIS_COLS - 4)) << 8;
			debris->x = x;
			debris->y = y;
		}
		y += 8 << 8;
	}
}

void
game()
{
	int obj, i;

	memset(&gi, 0, sizeof gi);
	gi.left = 3;

	for(;;) {
		round_init();
		for(;;) {
			schedule();

			ship_work();
			debris_work();

			obj = 0;
			obj = field_disp(obj);
			spcls(obj);

			if(!gi.ship[0].stat || !gi.ship[1].stat) break;
		}
		if(!gi.ship[0].stat) { /* vC[jH */
			gi.left--; /* c@炷 */
			if(gi.left == 0) break; /* Q[I[o[H */
		} else {
			gi.round++; /* EhAbv */
		}
	}

	/* CA覐΂NAB */
	memset(gi.ship, 0, sizeof gi.ship);
	memset(gi.debris, 0, sizeof gi.debris);

	/* GAMEOVER\B */
	grcls(-1);
	for(i = 0; i < SEC(3); i++) {
		schedule();
		if((i >= SEC(1)) && (joy & (TRG_A | TRG_B))) break; /* 1bȍ~̓LZ\ */
		grputstr(1, 5, "GAME OVER", 0xf0);
		obj = 0;
		obj = field_disp(obj);
		spcls(obj);
	}

	/* nCXRAXVB */
	if(gi.score > hiscore) hiscore = gi.score;
}

/****************************************************************************
 *	ship_work
 ****************************************************************************/

void
ship_work()
{
	int side, col, row, ctl, i, x, y;
	SHIP *ship, *enemy;
	DEBRIS* debris;

	for(side = 0; side < 2; side++) {
		ship = &gi.ship[side];
		enemy = &gi.ship[side ^ 1];
		switch(ship->stat) {
		case SHIP_NORMAL:
			/* Rg[擾B */
			if(side == 0 && !(joy & PAD_SELECT)) { /* B:SELECTĂ玩c */
				ctl = joy;
			} else {
				ctl = ship_think(side);
			}
			/* ړB */
			if(ctl & PAD_LF) ship->x -= SHIP_SPEED;
			if(ctl & PAD_RI) ship->x += SHIP_SPEED;
			if(ship->x < SHIP_X_MIN) {
				ship->x = SHIP_X_MIN;
				ship->ai[0] = PAD_RI;
			}
			if(ship->x > SHIP_X_MAX) {
				ship->x = SHIP_X_MAX;
				ship->ai[0] = PAD_LF;
			}
			/* [U[ˁB */
			if(ctl & (TRG_A | TRG_B)) {
				sound(0);
				ship->stat = SHIP_LASER;
				ship->cnt = 0;
				goto L10;
			}
			/* R`[WB */
			ship->fuel++;
			if(ship->fuel > 100) ship->fuel = 100;
			break;
		case SHIP_LASER:
L10:
			/* 1t[2R}܂Ői݂܂B */
			for(i = 0; i < 2; i++) {
				/* 葤ɓBς݂AR؂Ȃ炱܂ŁB */
				if(ship->cnt >= 10 || ship->fuel < SHIP_FUEL_UNIT) {
					ship->stat = SHIP_FREEZE;
					ship->cnt = 0;
					goto L20;
				}
				/* [U[L΂AR炷B */
				ship->cnt++;
				ship->fuel -= SHIP_FUEL_UNIT;
				/* [U[`B */
				x = ship->x >> 8;
				y = ship->y >> 8;
				if(side == 0) {
					if(ship->cnt < 10) {
						line(x, y - 8, x, y - (4 + 8 * ship->cnt), 0);
					} else {
						line(x, y - 8, x, y - (8 + 8 * ship->cnt), 0); /* Ō1t[͂Ɖʒ[܂œB */
					}
				} else {
					if(ship->cnt < 10) {
						line(x, y + 8, x, y + (4 + 8 * ship->cnt), 0);
					} else {
						line(x, y + 8, x, y + (8 + 8 * ship->cnt), 0); /* Ō1t[͂Ɖʒ[܂œB */
					}
				}
				/* 覐΂Ƃ̓蔻B */
				row = ship->cnt - 2;
				if(0 <= row && row <= DEBRIS_ROWS - 1) {
					if(side == 0) row = (DEBRIS_ROWS - 1) - row;
					for(col = 0; col < DEBRIS_COLS; col++) {
						debris = &gi.debris[row][col];
						if(!debris->stat) continue;
						x = abs(debris->x - ship->x) >> 8;
						if(x <= 3) {
							/* 覐ΔjB */
							sound(1);
							debris->stat = DEBRIS_BREAK;
							debris->cnt = 0;
							/* XRAZB */
							if(side == 0) {
								gi.score += (ship->cnt - 1) * 10; /* OA10,20,...,70_ */
							}
							/* [U[܂ŁB */
							ship->stat = SHIP_FREEZE;
							ship->cnt = 0;
							goto L20;
						}
					}
				}
				if(ship->cnt == 10) {
					x = abs(ship->x - enemy->x) >> 8;
					if(x <= 6) {
						/* CjB */
						sound(2);
						enemy->stat = SHIP_BREAK;
						enemy->cnt = 0;
						/* XRAZB */
						if(side == 0) {
							gi.score += 1000;
						}
						/* [U[܂ŁB */
						ship->stat = SHIP_FREEZE;
						ship->cnt = 0;
						goto L20;
					}
				}
			}
L20:
			break;
		case SHIP_FREEZE:
			/* dԂIA[U[āAʏԂցB */
			if(ship->cnt < SHIP_FREEZE_TIME) {
				ship->cnt++;
			} else {
				x = ship->x >> 8;
				y = ship->y >> 8;
				line(x, 0, x, DISP_Y - 1, -1);
				if(enemy->stat == SHIP_BREAK) {
					ship->stat = SHIP_WAIT; /* 肪jȂARg[s */
				} else {
					ship->stat = SHIP_NORMAL;
				}
				ship->cnt = 0;
			}
			break;
		case SHIP_BREAK:
			/* mɃ[U[܂Biuxŕꍇ̂߁j */
			x = ship->x >> 8;
			y = ship->y >> 8;
			line(x, 0, x, DISP_Y - 1, -1);
			if(ship->cnt < SHIP_BREAK_TIME) {
				ship->cnt++;
			} else {
				ship->stat = 0;
				ship->cnt = 0;
			}
			break;
		}
	}
}

/****************************************************************************
 *	debris_work
 ****************************************************************************/

void
debris_work()
{
	int row, col;
	DEBRIS* debris;

	for(row = 0; row < DEBRIS_ROWS; row++) {
		for(col = 0; col < DEBRIS_COLS; col++) {
			debris = &gi.debris[row][col];
			switch(debris->stat) {
			case DEBRIS_NORMAL:
				if(debris->dir == 0) { /* ړ */
					debris->x -= DEBRIS_SPEED;
					while(debris->x < DEBRIS_X_MIN) {
						debris->x += DEBRIS_X_MAX - DEBRIS_X_MIN;
					}
				} else { /* Eړ */
					debris->x += DEBRIS_SPEED;
					while(debris->x > DEBRIS_X_MAX) {
						debris->x -= DEBRIS_X_MAX - DEBRIS_X_MIN;
					}
				}
				break;
			case DEBRIS_BREAK:
				debris->cnt++;
				if(debris->cnt >= SEC(0.2)) {
					memset(debris, 0, sizeof(DEBRIS));
				}
				break;
			}
		}
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

static const char info[] = 
"FUEL \n"
"1P%3d\n"	/* gi.ship[0].fuel */
"2P%3d\n"	/* gi.ship[1].fuel */
"     \n"
"SCORE\n"
"HI   \n"
"%05d\n"	/* hiscore */
"1P   \n"	/* gi.score */
"%05d\n"
"     \n"
"SHIP%d\n";	/* gi.left-1 */

int
field_disp(int obj)
{
	int side, col, row, x, y, left;
	const CHR* chr;
	SHIP* ship;
	DEBRIS* debris;

	/* C\B */
	for(side = 0; side < 2; side++) {
		ship = &gi.ship[side];
		if(!ship->stat) continue;
		x = ship->x >> 8;
		y = ship->y >> 8;
		chr = &chr_ship[side][0];
		switch(ship->stat) {
		case SHIP_BREAK:
			chr = &chr_ship[side][1 + (ship->cnt >> 1 & 1)];
			break;
		}
		if(chr != NULL) obj = chdisp(obj, x, y, chr);
	}

	/* 覐Ε\B */
	for(row = 0; row < DEBRIS_ROWS; row++) {
		for(col = 0; col < DEBRIS_COLS; col++) {
			debris = &gi.debris[row][col];
			if(!debris->stat) continue;
			x = debris->x >> 8;
			y = debris->y >> 8;
			chr = &chr_debris[debris->dir];
			switch(debris->stat) {
			case DEBRIS_BREAK:
				chr = &chr_debris[2];
				break;
			}
			if(chr != NULL) obj = chdisp(obj, x, y, chr);
		}
	}

	/* _ȂǕ\B */
	left = gi.left - 1;
	if(left < 0) left = 0;
	if(left > 9) left = 9;
	grprintf(11, 0, 0x30, info,
		gi.ship[0].fuel <= 99999 ? gi.ship[0].fuel : 99999,
		gi.ship[1].fuel <= 99999 ? gi.ship[1].fuel : 99999,
		hiscore <= 99999 ? hiscore : 99999,
		gi.score <= 99999 ? gi.score : 99999,
		left);

	return obj;
}

/****************************************************************************
 *	ship_think
 ****************************************************************************/

static int move_sec[] = {
	SEC(1),
	SEC(0.9),
	SEC(0.8),
	SEC(0.7),
	SEC(0.6),
	SEC(0.5),
	SEC(0.4),
	SEC(0.3),
	SEC(0.2),
	SEC(0.1),
};
#define N_MOVE_SEC (sizeof move_sec / sizeof *move_sec)

static int diff_tbl[] = {
	1,
	9,
	2,
	8,
	3,
	7,
	4,
	5,
	6,
};
#define N_DIFF (sizeof diff_tbl / sizeof *diff_tbl)

int
ship_think(int side)
{
	int ctl, col, row, diff, diff_lim;
	SHIP *ship, *enemy;
	DEBRIS* debris;

	ship = &gi.ship[side];
	enemy = &gi.ship[side ^ 1];

	if(ship->ai[1] > 0) {
		ship->ai[1]--;
	} else {
		if(ship->fuel >= 50 || ship->fuel - enemy->fuel > -10) {
			if(ship->x < enemy->x) {
				ship->ai[0] = PAD_RI;
			} else {
				ship->ai[0] = PAD_LF;
			}
		} else {
			if(ship->x < enemy->x) {
				ship->ai[0] = PAD_LF;
			} else {
				ship->ai[0] = PAD_RI;
			}
		}
		if(gi.round < N_MOVE_SEC) {
			ship->ai[1] = move_sec[gi.round];
		} else {
			ship->ai[1] = move_sec[N_MOVE_SEC - 1];
		}
	}
	ctl = ship->ai[0];

	if(ship->fuel >= 50) {
		diff = abs(ship->x - enemy->x) >> 8;
		if(gi.round < N_DIFF) {
			diff_lim = diff_tbl[gi.round];
		} else {
			diff_lim = diff_tbl[N_DIFF - 1];
		}
		if(diff > diff_lim) goto L10;
		for(row = 0; row < DEBRIS_ROWS; row++) {
			for(col = 0; col < DEBRIS_COLS; col++) {
				debris = &gi.debris[row][col];
				if(!debris->stat) continue;
				if((abs(debris->x - ship->x) >> 8) < 3) goto L10;
			}
		}
		ctl |= TRG_A;
	}
L10:

	return ctl;
}
